int Animate(SceSize args, void *argp)
{
	Animation[Animation_Index].Stage = 0;
	while(1){
		sceDisplayWaitVblankStart();
		sceKernelDelayThread(Animation[Animation_Index].Delay);
		Animation[Animation_Index].Stage++;
    if (Animation[Animation_Index].Stage >= Animation[Animation_Index].MaxStages){
      if (Animation[Animation_Index].Repeat == 1){
        Animation[Animation_Index].Stage = 0;
      } else{
        Animation[Animation_Index].Stage -= 1;
      }
    }
	}
	return 0;
}

void SetAnimation(int index){
	if (Animation_Index != index){
		Animation_Index = index;
		sceKernelTerminateDeleteThread(ThreadID_Animate);
		ThreadID_Animate = sceKernelCreateThread("Animate", Animate, 0x18, 0x10000, PSP_THREAD_ATTR_USER, NULL);
		if (ThreadID_Animate < 0){oslFatalError("Unable to create animation thread.");}
		else{sceKernelStartThread(ThreadID_Animate, 0, NULL);}
	}
}

void NewAnimation(int sheet, int startrow, int imgwidth, int imgheight, int maxstages, int delay, int repeat){
	Animation = realloc(Animation, (AnimationSet_Count + 1) * sizeof(struct AnimationSet));
	Animation[AnimationSet_Count].Sheet = sheet;
	Animation[AnimationSet_Count].StartRow = startrow;
	Animation[AnimationSet_Count].ImgWidth = imgwidth;
	Animation[AnimationSet_Count].ImgHeight = imgheight;
	Animation[AnimationSet_Count].Stage = 0;
	Animation[AnimationSet_Count].MaxStages = maxstages;
	Animation[AnimationSet_Count].Delay = delay;
	Animation[AnimationSet_Count].Repeat = repeat;
	AnimationSet_Count += 1;
}

void SetX(int x){
  Sheet[Animation[Animation_Index].Sheet]->x = x;
}

void SetY(int y){
  Sheet[Animation[Animation_Index].Sheet]->y = y;
}

void MoveX(int x){
  //Variables
  int RaymanStart = Sheet[Animation[Animation_Index].Sheet]->x + Rayman_Start_Gap_X;
  int RaymanEnd = RaymanStart + Rayman_Width;
  int LevelFreedom = 480 - Level_Width;
  //Check For Collisions & Reduce X Appropriately
  if (x < - RaymanStart){
    x = - RaymanStart;
  }
  if (x > 480 - RaymanEnd){
    x = 480 - RaymanEnd;
  }
  //Move
  if (x < 0){
    int dif = RaymanStart - 280;
    if (Level_Position_X >= 0 || dif >= -x){
      Sheet[Animation[Animation_Index].Sheet]->x += x;
    } else{
      if (dif > 0 && dif < -x){
        Sheet[Animation[Animation_Index].Sheet]->x -= dif;
        x += dif;
        dif = 0;
      }
      if (dif <= 0){
        if (Level_Position_X - x > 0){
          Sheet[Animation[Animation_Index].Sheet]->x += Level_Position_X;
          Level_Position_X = 0;
        } else{
          Level_Position_X -= x;
        }
      }
    }
  } else{
    int dif = 200 - RaymanEnd;
    if (Level_Position_X <= LevelFreedom || dif >= x){
      Sheet[Animation[Animation_Index].Sheet]->x += x;
    } else{
      if (dif > 0 && dif < x){
        Sheet[Animation[Animation_Index].Sheet]->x += dif;
        x -= dif;
        dif = 0;
      }
      if (dif <= 0){
        if (Level_Position_X - x < LevelFreedom){
          Sheet[Animation[Animation_Index].Sheet]->x += Level_Position_X - LevelFreedom;
          Level_Position_X = LevelFreedom;
        } else{
          Level_Position_X -= x;
        }
      }
    }
  }
}

void MoveY(int y){
  //Variables
  int RaymanStart = Sheet[Animation[Animation_Index].Sheet]->y + Rayman_Start_Gap_Y;
  int RaymanEnd = RaymanStart + Rayman_Height;
  int LevelFreedom = 272 - Level_Height;
  //Check For Collisions & Reduce Y Appropriately
  y = NextYCollision(y);
  //Move
  Sheet[Animation[Animation_Index].Sheet]->y += y;
}

void AdjustCamera(){
  int tochange = 0;
  int RaymanStart = Sheet[Animation[Animation_Index].Sheet]->x + Rayman_Start_Gap_X;
  int RaymanEnd = RaymanStart + Rayman_Width;
  int LevelFreedom = 480 - Level_Width;
  if (Rayman_Direction == 0){
    if (RaymanStart < 280 && Level_Position_X < 0){
      tochange = 280 - RaymanStart;
      if (Level_Position_X + tochange >= 0){tochange = -Level_Position_X;}
    }
  } else{
    if (RaymanEnd > 200 && Level_Position_X > LevelFreedom){
      tochange = 200 - RaymanEnd;
      if (Level_Position_X + tochange <= LevelFreedom){tochange = LevelFreedom - Level_Position_X;}
    }
  }
  if (tochange >= 4){
    Level_Position_X += 4;
    Sheet[Animation[Animation_Index].Sheet]->x += 4;
  } else if (tochange <= -4){
    Level_Position_X -= 4;
    Sheet[Animation[Animation_Index].Sheet]->x -= 4;
  } else{
    Level_Position_X += tochange;
    Sheet[Animation[Animation_Index].Sheet]->x += tochange;
  }
}

void ControlJump(){
	//if (AnimationIndex != 3){IsLanding = 0;}
	if (Rayman_Jumping == 1){
    int increments[7] = {50, 70, 95, 105, 115, 122, 125};
    int i = 0;
		for (i = 0; i < 7; i++){
      if (Rayman_Jump_Height < increments[i]){
        Rayman_Jump_Height += 7 - i;
        MoveY(i - 7);
        return;
      }
		}
	}
}

void ApplyGravity(){
	if (Rayman_Jumping == 0 || (Rayman_Jumping == 1 && Rayman_Jump_Height >= 125)){
		int ybefore = Sheet[Animation[Animation_Index].Sheet]->y;
		int levelposy = Level_Position_Y;
		int increments[6] = {5, 10, 15, 25, 40, 60};
		int i = 0;
		for (i = 0; i < 6; i++){
      if (Rayman_Fall_Distance < increments[i]){
        Rayman_Fall_Distance += i + 1;
        MoveY(i + 1);
        return;
      }
		}
		Rayman_Fall_Distance += 7;
    MoveY(7);
		if (Sheet[Animation[Animation_Index].Sheet]->y <= ybefore && Level_Position_Y >= levelposy){
			Rayman_Fall_Distance = 0;
		}
	} else{
		Rayman_Fall_Distance = 0;
	}
}
